/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.61 Revision 1.131
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.131 2012/05/20 10:26:05 vapier Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10# 12
11# NB: If you add anything, please comment it! 13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
12 18
13inherit eutils libtool 19inherit eutils libtool
20
21# @ECLASS-VARIABLE: WANT_AUTOCONF
22# @DESCRIPTION:
23# The major version of autoconf your package needs
24: ${WANT_AUTOCONF:=latest}
25
26# @ECLASS-VARIABLE: WANT_AUTOMAKE
27# @DESCRIPTION:
28# The major version of automake your package needs
29: ${WANT_AUTOMAKE:=latest}
30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
38# @DESCRIPTION:
39# CONSTANT!
40# The latest major version/slot of automake available on each arch. #312315
41# If a newer slot is stable on any arch, and is NOT reflected in this list,
42# then circular dependencies may arise during emerge @system bootstraps.
43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
14 47
15_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch 52 none) _automake_atom="" ;; # some packages don't require automake at all
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 53 # if you change the "latest" version here, change also autotools_run_tool
54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac 64 esac
65 export WANT_AUTOMAKE
23fi 66fi
24 67
25if [[ -n ${WANT_AUTOCONF} ]] ; then 68if [[ -n ${WANT_AUTOCONF} ]] ; then
26 case ${WANT_AUTOCONF} in 69 case ${WANT_AUTOCONF} in
70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
72 # if you change the "latest" version here, change also autotools_env_setup
28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
29 esac 75 esac
76 export WANT_AUTOCONF
30fi 77fi
31DEPEND="${_automake_atom} 78
32 ${_autoconf_atom} 79_libtool_atom="sys-devel/libtool"
33 sys-devel/libtool" 80if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87fi
88
89AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
34RDEPEND="" 90RDEPEND=""
91
92# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
93# @DESCRIPTION:
94# Set to 'no' to disable automatically adding to DEPEND. This lets
95# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
96# their own DEPEND string.
97: ${AUTOTOOLS_AUTO_DEPEND:=yes}
98if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
99 DEPEND=${AUTOTOOLS_DEPEND}
100fi
101
35unset _automake_atom _autoconf_atom 102unset _automake_atom _autoconf_atom
36 103
37# Variables: 104# @ECLASS-VARIABLE: AM_OPTS
38# 105# @DEFAULT_UNSET
39# AT_M4DIR - Additional director(y|ies) aclocal should search 106# @DESCRIPTION:
40# AM_OPTS - Additional options to pass to automake during 107# Additional options to pass to automake during
41# eautoreconf call. 108# eautoreconf call.
109
110# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
111# @DEFAULT_UNSET
112# @DESCRIPTION:
113# Don't run eautomake command if set to 'yes'; only used to workaround
114# broken packages. Generally you should, instead, fix the package to
115# not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
116
117# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
118# @DEFAULT_UNSET
119# @DESCRIPTION:
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 120# Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with 121# useful when elibtoolize needs to be ran with
44# particular options 122# particular options
45 123
46# Functions: 124# @ECLASS-VARIABLE: AT_M4DIR
47# 125# @DESCRIPTION:
48# eautoreconf() - Should do a full autoreconf - normally what most people 126# Additional director(y|ies) aclocal should search
49# will be interested in. Also should handle additional 127: ${AT_M4DIR:=}
50# directories specified by AC_CONFIG_SUBDIRS.
51# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
52# to search for macro's.
53# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
54# with elibtoolize() from libtool.eclass
55# eautoconf - Runs autoconf.
56# eautoheader - Runs autoheader.
57# eautomake - Runs automake
58#
59 128
60# XXX: M4DIR should be depreciated 129# @ECLASS-VARIABLE: AT_SYS_M4DIR
61AT_M4DIR=${AT_M4DIR:-${M4DIR}} 130# @INTERNAL
62AT_GNUCONF_UPDATE="no" 131# @DESCRIPTION:
132# For system integrators, a list of additional aclocal search paths.
133# This variable gets eval-ed, so you can use variables in the definition
134# that may not be valid until eautoreconf & friends are run.
135: ${AT_SYS_M4DIR:=}
63 136
64 137# @FUNCTION: eautoreconf
138# @DESCRIPTION:
65# This function mimes the behavior of autoreconf, but uses the different 139# This function mimes the behavior of autoreconf, but uses the different
66# eauto* functions to run the tools. It doesn't accept parameters, but 140# eauto* functions to run the tools. It doesn't accept parameters, but
67# the directory with include files can be specified with AT_M4DIR variable. 141# the directory with include files can be specified with AT_M4DIR variable.
142#
143# Should do a full autoreconf - normally what most people will be interested in.
144# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
68eautoreconf() { 145eautoreconf() {
69 local pwd=$(pwd) x auxdir 146 local x g
70 147
71 if [[ -z ${AT_NO_RECURSIVE} ]]; then 148 if [[ -z ${AT_NO_RECURSIVE} ]]; then
72 # Take care of subdirs 149 # Take care of subdirs
73 for x in $(autotools_get_subdirs); do 150 for x in $(autotools_get_subdirs); do
74 if [[ -d ${x} ]] ; then 151 if [[ -d ${x} ]] ; then
75 cd "${x}" 152 pushd "${x}" >/dev/null
76 AT_NOELIBTOOLIZE="yes" eautoreconf 153 AT_NOELIBTOOLIZE="yes" eautoreconf
77 cd "${pwd}" 154 popd >/dev/null
78 fi 155 fi
79 done 156 done
80 fi 157 fi
81 158
82 auxdir=$(autotools_get_auxdir) 159 local auxdir=$(autotools_get_auxdir)
160 local macdir=$(autotools_get_macrodir)
83 161
84 einfo "Running eautoreconf in '$(pwd)' ..." 162 einfo "Running eautoreconf in '${PWD}' ..."
85 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 163 [[ -n ${auxdir}${macdir} ]] && mkdir -p ${auxdir} ${macdir}
86 eaclocal 164 eaclocal
165 [[ ${CHOST} == *-darwin* ]] && g=g
166 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
167 _elibtoolize --copy --force --install
168 else
87 _elibtoolize --copy --force 169 _elibtoolize --copy --force
170 fi
88 eautoconf 171 eautoconf
89 eautoheader 172 eautoheader
90 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 173 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
91 174
92 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 175 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
93 176
94 # Call it here to prevent failures due to elibtoolize called _before_ 177 # Call it here to prevent failures due to elibtoolize called _before_
95 # eautoreconf. 178 # eautoreconf. We set $S because elibtoolize runs on that #265319
96 elibtoolize 179 S=${PWD} elibtoolize --force
97 180
98 return 0 181 return 0
99} 182}
100 183
184# @FUNCTION: eaclocal_amflags
185# @DESCRIPTION:
186# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
187# (most) of the crazy crap that people throw at us.
188eaclocal_amflags() {
189 local aclocal_opts amflags_file
190
191 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
192 [[ -e ${amflags_file} ]] || continue
193 # setup the env in case the pkg does something crazy
194 # in their ACLOCAL_AMFLAGS. like run a shell script
195 # which turns around and runs autotools. #365401
196 # or split across multiple lines. #383525
197 autotools_env_setup
198 aclocal_opts=$(sed -n \
199 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
200 # match the first line
201 s:[^=]*=::p; \
202 # then gobble up all escaped lines
203 : nextline /\\\\$/{ n; p; b nextline; } \
204 }" ${amflags_file})
205 eval aclocal_opts=\""${aclocal_opts}"\"
206 break
207 done
208
209 echo ${aclocal_opts}
210}
211
212# @FUNCTION: eaclocal
213# @DESCRIPTION:
101# These functions runs the autotools using autotools_run_tool with the 214# These functions runs the autotools using autotools_run_tool with the
102# specified parametes. The name of the tool run is the same of the function 215# specified parametes. The name of the tool run is the same of the function
103# without e prefix. 216# without e prefix.
104# They also force installing the support files for safety. 217# They also force installing the support files for safety.
218# Respects AT_M4DIR for additional directories to search for macro's.
105eaclocal() { 219eaclocal() {
106 local aclocal_opts
107
108 if [[ -n ${AT_M4DIR} ]] ; then
109 for x in ${AT_M4DIR} ; do
110 case "${x}" in
111 "-I")
112 # We handle it below
113 ;;
114 *)
115 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
116 aclocal_opts="${aclocal_opts} -I ${x}"
117 ;;
118 esac
119 done
120 fi
121
122 autotools_set_versions
123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 220 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
124 autotools_run_tool aclocal "$@" ${aclocal_opts} 221 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
125} 222}
126 223
224# @FUNCTION: _elibtoolize
225# @DESCRIPTION:
226# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
227# libtool.eclass.
127_elibtoolize() { 228_elibtoolize() {
128 local opts 229 local opts g=
129 local lttest
130 230
131 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 231 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
132 # check for both it and the current AC_PROG_LIBTOOL) 232 # check for both it and the current AC_PROG_LIBTOOL)
133 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 233 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
134 [[ -n $lttest ]] || return 0
135 234
136 [[ -f Makefile.am ]] && opts="--automake" 235 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
137 236
138 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 237 [[ ${CHOST} == *-darwin* ]] && g=g
139 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 238 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
140 239
141 # Need to rerun aclocal 240 # Need to rerun aclocal
142 eaclocal 241 eaclocal
143} 242}
144 243
244# @FUNCTION: eautoheader
245# @DESCRIPTION:
246# Runs autoheader.
145eautoheader() { 247eautoheader() {
146 # Check if we should run autoheader 248 # Check if we should run autoheader
147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 249 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions 250 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
149 NO_FAIL=1 autotools_run_tool autoheader "$@"
150} 251}
151 252
253# @FUNCTION: eautoconf
254# @DESCRIPTION:
255# Runs autoconf.
152eautoconf() { 256eautoconf() {
153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 257 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
154 echo 258 echo
155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 259 eerror "No configure.{ac,in} present in '${PWD}'!"
156 echo 260 echo
157 die "No configure.{ac,in} present!" 261 die "No configure.{ac,in} present!"
158 fi 262 fi
159 263
160 autotools_set_versions
161 autotools_run_tool autoconf "$@" 264 autotools_run_tool --at-m4flags autoconf "$@"
162} 265}
163 266
267# @FUNCTION: eautomake
268# @DESCRIPTION:
269# Runs automake.
164eautomake() { 270eautomake() {
165 local extra_opts 271 local extra_opts
272 local makefile_name
166 273
167 [[ -f Makefile.am ]] || return 0 274 # Run automake if:
275 # - a Makefile.am type file exists
276 # - the configure script is using the AM_INIT_AUTOMAKE directive
277 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
278 [[ -f ${makefile_name} ]] && break
279 done
168 280
169 autotools_set_versions 281 if [[ -z ${makefile_name} ]] ; then
282 # Really we should just use autotools_check_macro ...
283 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
284 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
285 return 0
286 fi
287
170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 288 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
171 local used_automake 289 local used_automake
172 local installed_automake 290 local installed_automake
173 291
174 installed_automake=$(automake --version | head -n 1 | \ 292 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
175 sed -e 's:.*(GNU automake) ::') 293 sed -e 's:.*(GNU automake) ::')
176 used_automake=$(head -n 1 < Makefile.in | \ 294 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
177 sed -e 's:.*by automake \(.*\) from .*:\1:') 295 sed -e 's:.*by automake \(.*\) from .*:\1:')
178 296
179 if [[ ${installed_automake} != ${used_automake} ]]; then 297 if [[ ${installed_automake} != ${used_automake} ]]; then
180 einfo "Automake used for the package (${used_automake}) differs from" 298 einfo "Automake used for the package (${used_automake}) differs from"
181 einfo "the installed version (${installed_automake})." 299 einfo "the installed version (${installed_automake})."
182 eautoreconf 300 eautoreconf
183 return 0 301 return 0
184 fi 302 fi
185 fi 303 fi
186 304
187 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 305 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
188 || extra_opts="${extra_opts} --foreign" 306 || extra_opts="${extra_opts} --foreign"
189 307
190 # --force-missing seems not to be recognized by some flavours of automake 308 # --force-missing seems not to be recognized by some flavours of automake
191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 309 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
192} 310}
193 311
194autotools_set_versions() { 312# @FUNCTION: eautopoint
195 [[ -n ${autotools_version_sets} ]] && return 0 313# @DESCRIPTION:
314# Runs autopoint (from the gettext package).
315eautopoint() {
316 autotools_run_tool autopoint "$@"
317}
196 318
197 if [[ -n ${WANT_AUTOCONF} ]]; then 319# @FUNCTION: config_rpath_update
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 320# @USAGE: [destination]
199 export WANT_AUTOCONF 321# @DESCRIPTION:
200 einfo "Requested autoconf ${WANT_AUTOCONF}" 322# Some packages utilize the config.rpath helper script, but don't
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)" 323# use gettext directly. So we have to copy it in manually since
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)" 324# we can't let `autopoint` do it for us.
203 else 325config_rpath_update() {
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/" 326 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
205 fi
206 327
207 if [[ -n ${WANT_AUTOMAKE} ]]; then 328 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
208 local latest_automake 329 [[ $# -eq 0 ]] && return 0
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 330
210 latest_automake="latest: " 331 einfo "Updating all config.rpath files"
211 for amver in 1.10 1.9 1.8 1.7 1.6; do 332 for dst in "$@" ; do
212 WANT_AUTOMAKE="${amver}" 333 einfo " ${dst}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break 334 cp "${src}" "${dst}" || die
214 done 335 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225} 336}
226 337
227# Internal function to run an autotools' tool 338# Internal function to run an autotools' tool
339autotools_env_setup() {
340 # We do the "latest" → version switch here because it solves
341 # possible order problems, see bug #270010 as an example.
342 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
343 local pv
344 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
345 # has_version respects ROOT, but in this case, we don't want it to,
346 # thus "ROOT=/" prefix:
347 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
348 done
349 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
350 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
351 fi
352 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
353}
228autotools_run_tool() { 354autotools_run_tool() {
355 # Process our own internal flags first
356 local autofail=true m4flags=false
357 while [[ -n $1 ]] ; do
358 case $1 in
359 --at-no-fail) autofail=false;;
360 --at-m4flags) m4flags=true;;
361 # whatever is left goes to the actual tool
362 *) break;;
363 esac
364 shift
365 done
366
367 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
368 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
369 fi
370
371 autotools_env_setup
372
229 local STDERR_TARGET="${T}/$$.out" 373 local STDERR_TARGET="${T}/$1.out"
374 # most of the time, there will only be one run, but if there are
375 # more, make sure we get unique log filenames
376 if [[ -e ${STDERR_TARGET} ]] ; then
230 local ris 377 local i=1
378 while :; do
379 STDERR_TARGET="${T}/$1-${i}.out"
380 [[ -e ${STDERR_TARGET} ]] || break
381 : $(( i++ ))
382 done
383 fi
231 384
232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 385 if ${m4flags} ; then
233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 386 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
387 fi
388
389 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
234 390
235 ebegin "Running $@" 391 ebegin "Running $@"
236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 392 "$@" >> "${STDERR_TARGET}" 2>&1
237 ris=$? 393 if ! eend $? && ${autofail} ; then
238 eend ${ris}
239
240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
241 echo 394 echo
242 eerror "Failed Running $1 !" 395 eerror "Failed Running $1 !"
243 eerror 396 eerror
244 eerror "Include in your bugreport the contents of:" 397 eerror "Include in your bugreport the contents of:"
245 eerror 398 eerror
246 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 399 eerror " ${STDERR_TARGET}"
247 echo 400 echo
248 die "Failed Running $1 !" 401 die "Failed Running $1 !"
249 fi 402 fi
250} 403}
251 404
252# Internal function to check for support 405# Internal function to check for support
253autotools_check_macro() { 406autotools_check_macro() {
254 [[ -f configure.ac || -f configure.in ]] && \ 407 [[ -f configure.ac || -f configure.in ]] || return 0
255 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 408 local macro
409 for macro ; do
410 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
411 done
256 return 0 412 return 0
257} 413}
258 414
415# Internal function to look for a macro and extract its value
416autotools_check_macro_val() {
417 local macro=$1 scan_out
418
419 autotools_check_macro "${macro}" | \
420 gawk -v macro="${macro}" \
421 '($0 !~ /^[[:space:]]*(#|dnl)/) {
422 if (match($0, macro ":(.*)$", res))
423 print res[1]
424 }' | uniq
425
426 return 0
427}
428
259# Internal function to get additional subdirs to configure 429# Internal function to get additional subdirs to configure
260autotools_get_subdirs() { 430autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
261 local subdirs_scan_out 431autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
432autotools_get_macrodir() { autotools_check_macro_val AC_CONFIG_MACRO_DIR ; }
262 433
263 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 434_autotools_m4dir_include() {
264 [[ -n ${subdirs_scan_out} ]] || return 0 435 local x include_opts
265 436
266 echo "${subdirs_scan_out}" | gawk \ 437 for x in "$@" ; do
267 '($0 !~ /^[[:space:]]*(#|dnl)/) { 438 case ${x} in
268 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res)) 439 # We handle it below
269 print res[1] 440 -I) ;;
270 }' | uniq 441 *)
442 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
443 include_opts+=" -I ${x}"
444 ;;
445 esac
446 done
271 447
272 return 0 448 echo ${include_opts}
273} 449}
450autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
451autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
274 452
275autotools_get_auxdir() { 453fi
276 local auxdir_scan_out
277
278 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
279 [[ -n ${auxdir_scan_out} ]] || return 0
280
281 echo ${auxdir_scan_out} | gawk \
282 '($0 !~ /^[[:space:]]*(#|dnl)/) {
283 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
284 print res[1]
285 }' | uniq
286
287 return 0
288}

Legend:
Removed from v.1.61  
changed lines
  Added in v.1.131

  ViewVC Help
Powered by ViewVC 1.1.20